unit UnitTrigmessMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,StrUtils, ComCtrls, StdCtrls, Grids, ToolWin, ImgList, ExtCtrls,
  Menus, Mask,math,IniFiles,UnitTrigmessPar, System.ImageList,system.ansistrings;

const
  iMaxPlen=16;
  iBemLen=20;
  iMaxZielp=50;
  dRhoG= 200/Pi; 			// Rho in Neugrad
  dRhoD= 180/Pi; 			// Rho in Altgrad
type
  TStandpunkt=Record
    sNR:Array[1..iMaxPlen] of Char;
    iCode:Longword;
    iZiele:LongWord;
    dLuftDruck:Double;
    dTemperatur:Double;
    dFernrohr:Double;
    dEDM:Double;
    sBem:Array[1..iBemLen] of Char;
    iTag:LongWord;
    iMonat:longWord;
    iJahr:longWord;
    dZeit:Double;
  end;
  TZielpunkt=Record
    sNr:Array[1..iMaxPlen] of Char;
    iCode:longWord;
    dTafel:Double;
    dReflektor:Double;
    dHz0:Double;
    dHz1:Double;
    dHz2:Double;
    dStrecke:Double;
    dSeitw:Double;
    dDH:Double;
    dZD0:Double;
    dZD1:Double;
    dZD2:Double;
    dEDMNR:Double;
    dDist:Double;
    dExz:Double;
    lDI:Boolean;
    sBem:Array[1..iBemlen] of Char
  end;
  TPIndex=Record
    PS:String[iMaxPlen];
    Rec:LongWord;
  end;

  TZielpunkte=Array[1..iMaxZielp] of TZielpunkt;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    EditPSCode: TEdit;
    EditPSDruck: TEdit;
    EditPSTemp: TEdit;
    EditFernrohr: TEdit;
    EditEDM: TEdit;
    GroupBox2: TGroupBox;
    StringGrid1: TStringGrid;
    EditTag: TEdit;
    EditZeit: TEdit;
    EditPSBem: TEdit;
    Label1: TLabel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    PopupMenu1: TPopupMenu;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ComboBoxPS: TComboBox;
    EditPS: TEdit;
    Einfuegen: TMenuItem;
    Loeschen: TMenuItem;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    GroupBox3: TGroupBox;
    Memo1: TMemo;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton19: TToolButton;
    Button1: TButton;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    Label2: TLabel;
    ComboBoxZP: TComboBox;
    procedure TrigmessInBEB;
    procedure DeleteStandpunkt(istart:Longword);
    procedure SchreibTrigmess(iStart:LongWord);
    procedure ModifyTrigmessbin;
    Procedure Richtungsmittel(var PS:TStandpunkt;var PZ:Tzielpunkte);
    procedure ZenitdistanzMittel(var PS:TStandpunkt;var PZ:Tzielpunkte);
    Procedure Knopftafelhoehe(PNR:String);
    procedure CheckDoppelmessungen(SEnder:TObject);
    Procedure LiesStandpunkt(iRec:LongWord);
    procedure ComboBoxPSSelect(Sender: TObject);
    procedure BuildPIndex;
    procedure BuildZPIndex;
    Procedure DisplayData;
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure ToolButton5Click(Sender: TObject);
    procedure EditPSCodeChange(Sender: TObject);
    procedure EditPSDruckChange(Sender: TObject);
    procedure EditPSTempChange(Sender: TObject);
    procedure EditFernrohrChange(Sender: TObject);
    procedure EditEDMChange(Sender: TObject);
    procedure EditPSBemChange(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure EditPSChange(Sender: TObject);
    procedure EinfuegenClick(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure LoeschenClick(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure StringGrid1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton12Click(Sender: TObject);
    procedure Memo1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure GroupBox3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ImportTrigmessbin;
    procedure ToolButton20Click(Sender: TObject);
    procedure ReadIniFile;
    procedure SaveIniFile;
    procedure ToolButton21Click(Sender: TObject);
    procedure ComboBoxZPSelect(Sender: TObject);
  private
    { Private-Deklarationen }
    PS:TStandpunkt;
    PZ:TZielpunkte;
    AktFileName:string;
    iVersion,iVer:LongWord;
    Modified:Boolean;
    DataLocked:Boolean;
    AktRow,AktCol:Integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

Procedure Mod400(var x:Double);
begin
  repeat
    If x>400 Then x:=x-400;
    If x<0 Then x:=x+400
  Until (x>=0) And (x<400);
End;

Procedure TForm1.Richtungsmittel(var PS:TStandpunkt;var PZ:Tzielpunkte);
var
 i:Integer;
 dWert:Double;
begin
  For i:=1 To PS.iZiele do
  begin
    dWert:=0;
    If (PZ[i].dHZ1>=0) And (PZ[i].dHz2>=0) Then
    begin
      If PZ[i].dHZ2>PZ[i].dHZ1 Then dwert:=-200
      Else dwert:=200;
      dWert:=(PZ[i].dHz1+PZ[i].dHZ2+dwert+2000)/2-1000;
      mod400(dwert);
      PZ[i].dHZ0:=dwert;
    end
    Else
    begin
      dwert:=-1E-10;
      If (PZ[i].dHZ2<0) And (PZ[i].dHz1>=0) Then
         dWert:=PZ[i].dHz1
      Else
        If (PZ[i].dHZ1<0) And (PZ[i].dHz2>=0) Then
           dWert:=PZ[i].dHz2;
    End;
    PZ[i].dHZ0:=dWert;
  end;
end;

Procedure TForm1.Zenitdistanzmittel(var PS:TStandpunkt;var PZ:Tzielpunkte);
var
  i:Integer;
  dwert:Double;
begin
  For i:=1 To PS.iZiele do
  begin
    dWert:=0;
    If (PZ[i].dZD1>0) And (PZ[i].dZD2>0) Then
      dWert:=(PZ[i].dZd1-PZ[i].dZD2+400)/2
    Else
      If (PZ[i].dZD1>0) And (PZ[i].dZD2=0) Then
        dWert:=PZ[i].dZD1
      Else
        If (PZ[i].dZD1=0) And (PZ[i].dZD2>0) Then
          dWert:=400-PZ[i].dZD2;
    PZ[i].dZD0:=dWert;
  end
End;

function StrPas(const Str: PAnsiChar): AnsiString;
begin
  Result := Str;
end;


procedure TForm1.DisplayData;
var i,j:Integer;
begin
  ComboBoxPS.Text:=StrPas(@PS.sNR);
  EditPS.Text:=strPas(@PS.sNR);
  EditPSCode.Text:=intToStr(PS.iCode);
  EditPSDRuck.Text:=Format('%6.2f',[PS.dLuftdruck]);
  EditPSTemp.Text:=Format('%3.1f',[PS.dTemperatur]);
  EditFernrohr.Text:=Format('%6.3f',[PS.dFernrohr]);
  EditEDM.Text:=Format('%6.3f',[PS.dEDM]);
  EditTag.Text:=Format('%2s%2s%2s',[RightStr('00'+IntTostr(PS.iTag),2),RightStr('00'+IntTostr(PS.iMonat),2),RightStr(IntTostr(PS.iJahr),2)]);
  EditZeit.Text:=Format('%4.2f',[PS.dZeit]);
  EditPSBem.Text:=Strpas(@PS.sBem);
  StringGrid1.RowCount:=PS.iZiele+1;
  with StringGrid1 do
  begin
    ColCount:=18;DefaultColWidth:=0;
    FixedCols:=0;FixedRows:=0;
    Cells[0,0]:='Zielpunkt';
    Cells[1,0]:='Code';
    Cells[2,0]:='Hz';
    Cells[3,0]:='Strecke';
    Cells[4,0]:='dH';
    Cells[5,0]:='V';
    Cells[6,0]:='T';
    Cells[7,0]:='R';
    Cells[8,0]:='DI';
    Cells[9,0]:='Exz';
    cells[10,0]:='Seitw.';
    cells[11,0]:='GerteNr.';
    Cells[12,0]:='Hz I';
    Cells[13,0]:='Hz II';
    if Pos('SONNENAZIMUT',PS.sBem)>0 then
    begin
      Cells[14,0]:='V I / MEZ I';
      Cells[15,0]:='VII / MEZII';
    end
    else
    begin
      Cells[14,0]:='V I';
      Cells[15,0]:='V II';
    end;
    Cells[16,0]:='Bemerkung';
    Cells[17,0]:='VIdx';
    for j:=0 to StringGrid1.ColCount-1 do
      if ColWidths[j]<Canvas.TextWidth(Cells[j,0])+4 then
        ColWidths[j]:=Canvas.TextWidth(Cells[j,0])+4;
    If PS.IZiele>0 then
    begin
      Rowcount:=PS.iZiele+1;
      FixedRows:=1;
    end
    else
    begin
      Rowcount:=0;
      FixedRows:=0;
    end;
    for i:=1 to PS.iZiele do
    begin
      StringGrid1.Rows[i].Clear;
      Cells[0,i]:=strpas(@PZ[i].sNr);
      if Pos('SONNE',Strpas(@PZ[i].sBem))=0 then
      begin
        Cells[1,i]:=Format('%6d',[PZ[i].iCode]);
        If PZ[i].dhz0>=0 then Cells[2,i]:=Format('%8.4f',[PZ[i].dHz0]) else Cells[2,i]:='';
        if (PZ[i].dStrecke>0)  then
          Cells[3,i]:=Trim(Format('%9.3f',[PZ[i].dStrecke]))
        else
          Cells[3,i]:='';
        If (PZ[i].ddH=0) and (PZ[i].dDist>0)and  (PZ[i].dZD0>0) Then
        begin
          PZ[i].ddH:=PZ[i].dDist*Cos(PZ[i].dZD0/dRhoG)+PS.dFernrohr-PZ[i].dTafel;
          Modified:=True;
        end;
        Cells[4,i]:=Format('%8.3f',[PZ[i].dDH]);
        Cells[5,i]:=Format('%8.4f',[PZ[i].dZD0]);
        Cells[6,i]:=Format('%6.3f',[PZ[i].dTafel]);
        Cells[7,i]:=Format('%6.3f',[PZ[i].dReflektor]);
        if (PZ[i].dDist>0)  then
          Cells[8,i]:=Format('%9.3f',[PZ[i].dDist])
        else
          Cells[8,i]:='';
        Cells[9,i]:=Format('%7.3f',[PZ[i].dExz]);
        Cells[10,i]:=Trim(Format('%7.3f',[PZ[i].dSeitw]));
        if (PZ[i].dStrecke>0) or (PZ[i].dDist>0) then
          Cells[11,i]:=Format('%10.2f',[PZ[i].dEDMNR])
        else
          Cells[11,i]:='';
      end;

      if PZ[i].dHz1>=0 then Cells[12,i]:=Format('%8.4f',[PZ[i].dHz1]) else Cells[12,i]:='';
      if PZ[i].dHz2>=0 then Cells[13,i]:=Format('%8.4f',[PZ[i].dHz2]) else Cells[13,i]:='';

      if Pos('SONNE',Strpas(@PZ[i].sBem))>0 then
      begin
        Cells[14,i]:=Format('%10.6f',[PZ[i].dZD1]);
        Cells[15,i]:=Format('%10.6f',[PZ[i].dZD2]);
      end
      else
      begin
        Cells[14,i]:=Format('%8.4f',[PZ[i].dZD1]);
        Cells[15,i]:=Format('%8.4f',[PZ[i].dZD2]);
        if (PZ[i].dZD1>0) and (PZ[i].dZD2>0) then
          Cells[17,i]:=Format('%8.0f',[(400-(PZ[i].dZD1+PZ[i].dZD2))/2*1E4]);
      end;
      Cells[16,i]:=strpas(@PZ[i].sBem);

      for j:=0 to StringGrid1.ColCount-1 do
      if ColWidths[j]<Canvas.TextWidth(Cells[j,i])+4 then
        ColWidths[j]:=Canvas.TextWidth(Cells[j,i])+4;
    end;
  end;
end;

procedure Tform1.TrigmessinBEB;
var
  f1:file;
  f2:Textfile;
  iStart:LongWord;
  i:Integer;
  S:String;

function sgn(x:Double):integer;
begin
  sgn:=0;
  if x<0 then sgn:=-1
  else if x>0 then sgn:=1;
end;

function hms_h(x:Double):Double;
    (* Eingabe: Grad.MinutenSekunden
       Ausgabe: Dezimalaltgrad
    *)
var y:double;
    minus:boolean;
begin
   minus:=x<0;x:=abs(x);
   y:=int(x); (* Grad *)
   x:=Frac(x);x:=x*100;
   y:=y+int(x)/60; (*Minuten*)
   x:=Frac(x);x:=x*100;
   y:=y+x/3600; (*Sekunden*)
   if minus then hms_h:=-y else hms_h:=y;
end;

function h_hms(x:Double):Double;
    (* Eingabe: Dezimalaltgrad
       Ausgabe: Grad.MinutenSekunden
    *)
var h,m,s:Double;
    minus:boolean;
begin
  minus:=x<0;x:=abs(x);
  h:=int(x);x:=frac(x)*60;
  m:=int(x);s:=frac(x)*60;
  if trunc(s)>=60 then
  begin
     m:=m+1;s:=s-60;
  end;
  if trunc(m)>=60 then
  begin
    h:=h+1;m:=m-60;
  end;
  h:=h+m/100+s/10000;
  if minus then h_hms:=-h else h_hms:=h;
end;

Function HMSForm(x:real;l,d:Integer):String;
      (* Eingabe Winkel in DEG.MMSSxxxx
         Format: l=Laenge,d=Dezimalstellen
         Ausgabe String in DEG MM SS.xxxx
      *)
var s:String;
    i:Integer;
begin
  str(x:l:d,S);
  i:=Pos('.',S);
  S[i]:=' ';
  Insert(' ',S,i+3);
  Insert('.',S,i+6);
  HMSForm:=S;
end;

procedure SchreibBebDat;
var
  i:Integer;
  dPSDruck,dDruck,dWert:Double;
  sEDMNRTYP,s1:String;

function Satzkennung(i:Integer):String;
var s:string;
begin
    If PS.iZiele<2 then PZ[i].dHz0:=-1E-10;

    If ((PZ[i].dDist>0) Or (PZ[i].dStrecke>0)) And (PZ[i].dZd0>0) And (PZ[i].dHz0>=0) Then
      s:='RG'
    Else
      If (PZ[i].dDist>0) And (PZ[i].dZd0=0) And (PZ[i].dHz0>=0) and (PS.iZiele>0) then
        s:='RD'
      Else
      If (PZ[i].dDist=0) And (PZ[i].dZD0>0) And (PZ[i].dHz0>=0) And (PZ[i].dStrecke=0) Then
        S:='RZ'
      Else
        If (PZ[i].dDist=0) And (PZ[i].dZD0=0) And (PZ[i].dHz0>=0) And (PZ[i].dStrecke=0) Then
          S:='RI'
        Else
          If (PZ[i].dDist>0) And (PZ[i].dHz0<0)  And (PZ[i].dZD0>0) Then
            s:='DZ'
          Else
            If (PZ[i].dDist>0) And (PZ[i].dHz0<0)  And (PZ[i].dZD0=0) Then
              s:='DD'
            Else
              If (PZ[i].dDist=0) And (PZ[i].dStrecke>0)  And (PZ[i].dZD0>0) Then
                s:='SZ'
              Else
                If (PZ[i].dDist=0) And (PZ[i].dStrecke>0)  And (PZ[i].dZD0=0) Then
                  s:='SS'
                Else
                  If (PZ[i].dDist=0) And (PZ[i].dStrecke>0)  And (PZ[i].dHz0>=0) And (PZ[i].dZD0=0) Then
                    s:='RS'
                  Else
                    If (PZ[i].dDist=0) And (PZ[i].dStrecke>0)  And (PZ[i].dHz0=0) And (PZ[i].dZD0=0) And (PZ[i].ddH<>0) Then
                     s:='SH'
                  else
                    If (PZ[i].dDist=0) And (PZ[i].dStrecke=0)  And (PZ[i].dHz0<0) And (PZ[i].dZD0>0) And (PZ[i].ddH=0) Then
                     s:='ZZ'
                     else
                       If (PZ[i].dDist=0) And (PZ[i].dStrecke=0)  And (PZ[i].dHz0<0) And (PZ[i].dZD0>0) And (PZ[i].ddH<>0) Then
                       s:='HZ';

    // Sonnenazimut
    if i>=1 then s1:=s;
    if (StrPas(@PZ[i].sBem)='SONNE') and (strScan(@PZ[i].sNR,'L')<>NIL) then
    s:='OL'
    else
     if (StrPas(@PZ[i].sBem)='SONNE') and (strScan(@PZ[i].sNR,'R')<>NIL) then
     s:='OR'
     else
       if (StrPas(@PZ[i].sBem)='SONNE') then
       s:='OO';
  Result:=S;
end;
begin

  If PS.dEDM=0 Then PS.dEDM:=PS.dFernrohr;

  dPSDruck:=PS.dLuftDruck;
  dDruck:=0;
  Writeln(f2,'CC Standpunkt         Code  Druck   Tag    Zeit   Bem.');
  s:=format('SP %-16s %5d %6.2f %2s%2s%2s %4.2f %s',[StrPas(@PS.sNR),PS.iCode,PS.dLuftDruck,RightStr('00'+IntTostr(PS.iTag),2),RightStr('00'+IntTostr(PS.iMonat),2),RightStr(IntTostr(PS.iJahr),2),PS.dZeit,strPas(@PS.sBem)]);
  Writeln(f2,s);
  if Pos('SONNENAZIMUT',StrPas(@PS.sBem))>0 then
    Writeln(f2,'CC RI-Zielp   RI-Sonne   TAG     MEZ');

  Writeln(f2,'CC Zielpunkt          Code        Hz          S     seitw.    dH          V        F        T        E        R       TT  TF    Druck      EDMNR    MG     DI       Exz.  Bem.');
  s:='CC';
  For i:=1 To PS.iZiele do
  begin
    s:=Satzkennung(i);

    If PZ[i].dDist>0 Then
      PZ[i].ddH:=PZ[i].dDist*Cos(PZ[i].dZD0/dRhoG)+PS.dFernrohr-PZ[i].dTafel;

    // Luftdruck wegen Hhenunterschied reduzieren
    If PZ[i].ddH <> 0 Then
      dDruck:= dPSDruck-(PZ[i].dDH-PS.dEDM+PZ[i].dReflektor)/2*dPSDruck/8019/(1+PS.dTemperatur*0.00367)
    else dDruck:=dPSDruck;
    If PZ[i].dDist=0 Then dDruck:=0;

    // Messgetetyp setzen
    If (PZ[i].dDist>0) Or (PZ[i].dStrecke>0) Then
      If PZ[i].lDI Then
          sEDMNRTYP:=Format('%12.2f DI',[PZ[i].dEDMNR])
      Else
        sEDMNRTYP:='        0    MB'
    Else
      sEDMNRTYP:='        0      ';

    If (Pos('SONNENAZIMUT',StrPas(@PS.sBem))>0) then
    begin
      if (pos(s,'OL OR OO')>0) and (i>1) then
      begin
        if PZ[i].dZD1>0 then
          Writeln(f2,s+Format('%10.4f %10.4f %2s%2s%2s %10.8f',[PZ[1].dHz1,PZ[i].dHz1,RightStr('00'+IntTostr(PS.iTag),2),RightStr('00'+IntTostr(PS.iMonat),2),RightStr(IntTostr(PS.iJahr),2),HMS_H(PZ[i].dZD1)]));
        if PZ[i].dZD2>0 then
          Writeln(f2,s+Format('%10.4f %10.4f %2s%2s%2s %10.8f',[PZ[1].dHz2,PZ[i].dHz2,RightStr('00'+IntTostr(PS.iTag),2),RightStr('00'+IntTostr(PS.iMonat),2),RightStr(IntTostr(PS.iJahr),2),HMS_H(PZ[i].dZD2)]));
      end;
      if i=PS.iZiele then
      begin
        If (PZ[1].dDist>0) Or (PZ[1].dStrecke>0) Then
          If PZ[1].lDI Then
            sEDMNRTYP:=Format('%12.2f DI',[PZ[1].dEDMNR])
          Else
            sEDMNRTYP:='        0    MB'
        Else
          sEDMNRTYP:='        0      ';
       If PZ[1].ddH <> 0 Then
         dDruck:= dPSDruck-(PZ[1].dDH-PS.dEDM+PZ[1].dReflektor)/2*dPSDruck/8019/(1+PS.dTemperatur*0.00367)
       else dDruck:=dPSDruck;
        s1:=Satzkennung(1);
        Writeln(f2,'A'+rightStr(s1,1)+format(' %-16s %7u %10.4f %9.3f %8.3f %9.3f %10.4f %8.3f %8.3f %8.3f %8.3f %6.1f 0.0 %8.2f %2s %9.3f %8.3f %s',
        [StrPas(@PZ[1].sNR),PZ[1].Icode,PZ[1].dHz0,PZ[1].dStrecke,PZ[1].dSeitw,PZ[1].ddH,PZ[1].dZD0,PS.dFernrohr,PZ[1].dTafel,PS.dEDM,PZ[1].dReflektor,PS.dTemperatur,dDruck,sEDMNRTYP,PZ[1].dDist,PZ[1].dExz,StrPas(@PZ[1].sBem)]));
      end;
    end
    else
    begin
      S:=S+format(' %-16s %7u %10.4f %9.3f %8.3f %9.3f %10.4f %8.3f %8.3f %8.3f %8.3f %6.1f 0.0 %8.2f %2s %9.3f %8.3f %s',
      [StrPas(@PZ[i].sNR),PZ[i].Icode,PZ[i].dHz0,PZ[i].dStrecke,PZ[i].dSeitw,PZ[i].ddH,PZ[i].dZD0,PS.dFernrohr,PZ[i].dTafel,PS.dEDM,PZ[i].dReflektor,PS.dTemperatur,dDruck,sEDMNRTYP,PZ[i].dDist,PZ[i].dExz,StrPas(@PZ[i].sBem)]);
      writeln(f2,s);
    end;

    // Bei Satzmessung beide Fernrohlagen als CC Kommentar dokumentieren
    If ((PZ[i].dHZ1>=0) And (PZ[i].dHZ2>=0)) Or ((PZ[i].dZD1>0) And (PZ[i].dZD2>0)) Then
    begin
      s:='CC';
      If (PZ[i].dHZ1>=0) And (PZ[i].dHZ2>=0) Then
      begin
        If PZ[i].dhz1>PZ[i].dhz2 Then
           dwert:=PZ[i].dHZ1-(PZ[i].dHZ2+200)
        Else
           dwert:=PZ[i].dHZ1-(PZ[i].dHZ2-200);

        While dwert>=400 do
        begin
          dwert:=dwert-400;
        end;

        s:=s+Format(' HzI %9.4f HzII %9.4f HzI-HzII %9.4f',[PZ[i].dHz1,PZ[i].dHz2,dwert]);
      End;

      If (PZ[i].dZD1>0) And (PZ[i].dZD2>0)  Then
        s:=s+Format(' VI %9.6f VII %9.6f i %9.4f',[PZ[i].dZD1,PZ[i].dZD2,(PZ[i].dZD1+PZ[i].dZD2-400)/2]);
      Writeln(f2,s);
    End;
  end;
  writeln(f2);
end;

procedure SchreibBebDatKopf;
begin
  writeln(f2,'CC    TRIGMESSEdit Ver. ',iVersion);
  writeln(f2,'CC    Bedeutung der Satzkennungen.');
  writeln(f2,'CC CC Kommentar');
  writeln(f2,'CC AU Auftragsbezeichnung');
  writeln(f2,'CC SP Standpunkt');
  writeln(f2,'CC RI Richtung');
  writeln(f2,'CC RS Richtung, Horizontalstrecke');
  writeln(f2,'CC RD Richtung, Schrgdistanz');
  writeln(f2,'CC RH Richtung, Hhenunterschied');
  writeln(f2,'CC RZ Richtung, Zenitdistanz');
  writeln(f2,'CC RG Richtung, Zenitdistanz oder Delta-H, Horizontal- oder Schrgentfernung');
  writeln(f2,'CC AI Richtunswinkel');
  writeln(f2,'CC AS Richtungswinkel, Horizontalstrecke');
  writeln(f2,'CC AD Richtungswinkel, Schrgstrecke');
  writeln(f2,'CC AH Richtungswinkel, Delta-H');
  writeln(f2,'CC AZ Richtungswinkel, Zenitdistanz');
  writeln(f2,'CC AG Richtungswinkel, Schrgstrecke, Zenitdistanz');
  writeln(f2,'CC SS Horizontalstrecke');
  writeln(f2,'CC SZ Horizontalstrecke, Zenitdistanz');
  writeln(f2,'CC SH Horizontalstrecke,Delta-H');
  writeln(f2,'CC DD Schrgstrecke');
  writeln(f2,'CC DZ Schgstrecke, Zenitdistanz');
  writeln(f2,'CC DH Schrgstrecke,Delta-H');
  writeln(f2,'CC HH Delta-H');
  writeln(f2,'CC HZ Delta-H, Zenitdistanz');
  writeln(f2,'CC ZZ Zenitdistanz');
  writeln(f2,'CC NI Niveauhhe');
  writeln(f2,'CC $S Raumvektor');
  writeln(f2,'CC RT Rotationsparameter Rx(")  Ry(")  Rz(") dM(ppm)');
  writeln(f2,'CC RF Dateiname GPS-Vektoren');
  writeln(f2,'CC AF Projektdateiname max. 8 Zeichen ohne Extension Bsp.: C:\PROJ\TEST');
  writeln(f2,'CC EL Bezugsellipsoid und Referenzgeoid(Denker)  1  1');
  writeln(f2,'CC KO Koordinatenoffset 3E6 5E6');
  writeln(f2,'CC TZ 0 Zerlegung in Netzteile 0=Nein 1=Ja');
  writeln(f2,'CC RE Richtung, reduzierte Horizontalstrecke');
  writeln(f2,'CC AE Richtungswinkel, reduzierte Horizontalstrecke');
  writeln(f2,'CC EE reduzierte Horizontalstrecke');
  writeln(f2,'CC EZ reduzierte Horizontalstrecke,Zenitwinkel');
  writeln(f2,'CC EH reduzierte Horizontalstrecke, Delta-H');
  writeln(f2,'CC RN Richtung, NN-reduzierte Horizontalstrecke');
  writeln(f2,'CC AN Richtungswinkel, NN-reduzierte Horizontalstrecke');
  writeln(f2,'CC NE NN-reduzierte Horizontalstrecke');
  writeln(f2,'CC NZ NN-reduzierte Horizontalstrecke,Zenitwinkel');
  writeln(f2,'CC NH NN-reduzierte Horizontalstrecke, Delta-H');
  writeln(f2,'CC EG Komplettmessung mit reduzierter Horizontalstrecke');
  writeln(f2,'CC NG Komplettmessung mit NN-Reduzierter Horizontalstrecke');
  writeln(f2,'CC GW MaxVST MaxVRQ MaxVDH Grenzwerte zur Markierung gober Fehler');
  writeln(f2,'CC KS Nullmeridian in  Koordinatensystem 0=Gau-Krger, 1=UTM');
  writeln(f2,'CC LS Bevorzugter Lagestatus fr Anschlupunkte');
  writeln(f2,'CC WF GPS-Punktdatei mit WGS84 Koordinaten');
  writeln(f2,'CC $K GPS-Punkt mit WGS84 Koordinaten');
  writeln(f2,'CC 7P Transformationsparameter fr GPS-Punkte (dX(m),dY(m),dZ(m),rX("),rY("),rZ("),dM(ppm)');
  writeln(f2,'CC OL Sonnenazimut linker Sonnenrand');
  writeln(f2,'CC OR Sonnenazimut rechter Sonnenrand');
  writeln(f2,'CC OO Sonnenazimut Sonnenmitte');
  writeln(F2);
  writeln(f2,'AF ',copy(name,1,length(name)-4));
  name:=ExtractFilename(name);
  writeln(f2,'AU ',copy(name,1,length(name)-4));
  writeln(f2,'GW 0.10 0.10 0.10  MaxVST  MaxVRQ  MaxVDH');
  writeln(f2,'KS 9  0   Nullmeridian Abbildung(0=Gau-Krger,1=UTM)');
  writeln(f2,'EL 1  3   Ellipsoid(1=Bessel,2=International,3=Krassowsky,4=WGS72,5=WGS84,6=GRS80)');
  writeln(f2,'CC        Geoid(0=Ohne,1=Denker-Lagerung Bessel Ellipsoid, 2=Denker-Lagerung ED50, 3=Denker-DHDN Basislagerung)');
  writeln(f2,'LS 100  Bevorzugter Lagestatus fr Anschlupunkte');
  writeln(f2,'CC Defaultwerte fr GPS-Transformationsparameter');
  writeln(f2,'CC RT 0.249 0.093 -2.133 -10.073 RX(") RY(") RZ(") dM(ppm) Parameter GPS-Vektoren WGS84 -> LS100');
  writeln(f2,'CC 7P -575.8883 -98.8529 -405.6148  1.08584 0.37382 -2.80457 -10.0059E-6 dX(m) dY(m) dZ(m) RX(") RY(") RZ(") dM(ppm) Parameter GPS Punkte WGS84 -> LS100');
  writeln(f2,'CC');
end;


begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  S:=copy(AktFilename,1,length(AktFileName)-3)+'BEB';;
  assignFile(f2,s);
  rewrite(f2);
  SchreibBebDatKopf;
  while not eof(f1) do
  begin
    Fillchar(PS,sizeof(PS),0);
    Fillchar(PZ,sizeof(PZ),0);
    BlockRead(f1,istart,4);
    Blockread(f1,PS.sNR,imaxPlen);
    Blockread(f1,iVer,4);
    Blockread(f1,PS.iCode,4);
    BlockRead(f1,PS.iZiele,4);
    BlockRead(f1,PS.dLuftdruck,SizeOf(Double));
    BlockRead(f1,PS.dTemperatur,SizeOf(double));
    BlockRead(f1,PS.dFernrohr,SizeOf(double));
    BlockRead(f1,PS.dEDM,SizeOf(double));
    BlockRead(f1,PS.sBem,iBemLen);
    BlockRead(f1,PS.iTag,4);
    BlockRead(f1,PS.iMonat,4);
    Blockread(f1,PS.iJahr,4);
    BlockRead(f1,PS.dZeit,SizeOf(Double));

    For i:=1 To PS.iZiele do
    begin
      BlockRead(f1,PZ[i].sNr,iMaxPlen);
      BlockRead(f1,PZ[i].iCode,4);
      BlockRead(f1,PZ[i].dTafel,SizeOf(Double));
      BlockRead(f1,PZ[i].dReflektor,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz0,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz1,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz2,SizeOf(Double));
      BlockRead(f1,PZ[i].dStrecke,SizeOf(Double));
      BlockRead(f1,PZ[i].dSeitw,SizeOf(Double));
      BlockRead(f1,PZ[i].dDH,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD0,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD1,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD2,SizeOf(Double));
      BlockRead(f1,PZ[i].dEDMNR,SizeOf(Double));
      BlockRead(f1,PZ[i].dDist,SizeOf(Double));
      BlockRead(f1,PZ[i].dExz,SizeOf(Double));
      BlockRead(f1,PZ[i].lDI,SizeOf(Boolean));
      BlockRead(f1,PZ[i].sBem,iBemLen);
    end;
    Richtungsmittel(PS,PZ);
    Zenitdistanzmittel(PS,PZ);
    SchreibBebdat;
    DisplayData;
  end;

  Closefile(f1);
  CloseFile(f2);
end;

procedure TForm1.DeleteStandpunkt(istart:Longword);
var f2:File;
    i,iEnd,iLen,ia,iFlen:Longword;
    buffer:array of Byte;
begin
  AssignFile(f2,AktFilename);
  reset(f2,1);
  seek(f2,iStart);
  BlockRead(f2,iend,4);
  iLen:=iEnd-1-iStart;
  setlength(Buffer,Sizeof(PS)+Sizeof(PZ)+100);
  iFlen:=Filesize(f2);
  repeat
    ia:=iend;
    if ia-1=iFlen then
    begin
      i:=iend-ilen;
    end
    else
    begin
      seek(f2,ia-1);
      BlockRead(f2,iend,4);
      seek(f2,ia-1);
      Blockread(f2,Buffer[0],iend-ia);
      seek(f2,ia-1-ilen);
      Blockwrite(f2,Buffer[0],iend-ia);
      seek(f2,ia-1-ilen);
      i:=iend-ilen;
      Blockwrite(f2,i,4);
    end;
  until iend-1>=iflen;
  seek(f2,i-1);
  Truncate(f2);
  Closefile(f2);
end;

procedure TForm1.SchreibTrigmess(iStart:LongWord);
var i:Integer;
    iEnd,iVer:LongWord;
    f2:File;
begin
  if Not Modified then exit;
  if strpas(@PS.sNR)<>ComboBoxPS.Items.Strings[ComboBoxPS.ItemIndex] then
  begin
    iEnd:=integer(ComboBoxPS.Items.Objects[ComboBoxPS.ItemIndex]);
    ComboBoxPS.Items.Delete(ComboBoxPS.ItemIndex);
    ComboBoxPS.Items.AddObject(strPas(@PS.SNr),Tobject(iEnd));
  end;

  AssignFile(f2,AktFilename);
  reset(f2,1);
  if (Stringgrid1.RowCount-1<>PS.iZiele) then
  begin
    DeleteStandpunkt(iStart);
    istart:=Filesize(f2);
    PS.iZiele:=StringGrid1.Rowcount-1;
    ComboBoxPS.Items.Objects[ComboBoxPS.ItemIndex]:=Tobject(iStart);
  end;

  seek(f2,iStart+4);
  BlockWrite(f2,PS.sNR,imaxPlen);
  iVer:=iVersion*1000;
  BlockWrite(f2,iVer,4); //201000 damit nochmalige konvertierung verhindert wird
  BlockWrite(f2,PS.iCode,4);
  BlockWrite(f2,PS.iZiele,4);
  BlockWrite(f2,PS.dLuftdruck,SizeOf(Double));
  BlockWrite(f2,PS.dTemperatur,SizeOf(double));
  BlockWrite(f2,PS.dFernrohr,SizeOf(double));
  BlockWrite(f2,PS.dEDM,SizeOf(double));
  BlockWrite(f2,PS.sBem,iBemLen);
  BlockWrite(f2,PS.iTag,4);
  BlockWrite(f2,PS.iMonat,4);
  BlockWrite(f2,PS.iJahr,4);
  BlockWrite(f2,PS.dZeit,SizeOf(Double));
  For i:=1 To PS.iZiele do
  begin
    BlockWrite(f2,PZ[i].sNr,iMaxPlen);
    BlockWrite(f2,PZ[i].iCode,4);
    BlockWrite(f2,PZ[i].dTafel,SizeOf(Double));
    BlockWrite(f2,PZ[i].dReflektor,SizeOf(Double));
    BlockWrite(f2,PZ[i].dHz0,SizeOf(Double));
    BlockWrite(f2,PZ[i].dHz1,SizeOf(Double));
    BlockWrite(f2,PZ[i].dHz2,SizeOf(Double));
    BlockWrite(f2,PZ[i].dStrecke,SizeOf(Double));
    BlockWrite(f2,PZ[i].dSeitw,SizeOf(Double));
    BlockWrite(f2,PZ[i].dDH,SizeOf(Double));
    BlockWrite(f2,PZ[i].dZD0,SizeOf(Double));
    BlockWrite(f2,PZ[i].dZD1,SizeOf(Double));
    BlockWrite(f2,PZ[i].dZD2,SizeOf(Double));
    BlockWrite(f2,PZ[i].dEDMNR,SizeOf(Double));
    BlockWrite(f2,PZ[i].dDist,SizeOf(Double));
    BlockWrite(f2,PZ[i].dExz,SizeOf(Double));
    BlockWrite(f2,PZ[i].lDI,SizeOf(Boolean));
    BlockWrite(f2,PZ[i].sBem,iBemLen);
  end;
  iEnd:=FilePos(f2);
  Seek(f2,iStart);
  iEnd:=iEnd+1;  // In GeoBasic hat das erste Byte den Index 1 und nicht 0 wie hier
  BlockWrite(f2,iEnd,4);
  Seek(f2,iEnd-1);
  Closefile(f2);
  Modified:=False;
  statusbar1.Simpletext:='Standpunkt gespeichert';
  Statusbar1.Update;
end;

procedure Tform1.ModifyTrigmessbin;
var
  f1,f2:file;
  iStart,iver:LongWord;
  PS:TStandpunkt;
  PZ:Array[1..iMaxZielp] of TZielpunkt;
  i,NumRead:Integer;
  Posstart,Posend:LongWord;
  S:String;

begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  S:=copy(aktfilename,1,length(AktFileName)-3)+'$$$';
  AssignFile(f2,s);
  rewrite(f2,1);
  while not eof(f1) do
  begin
    Fillchar(PS,sizeof(PS),0);
    Fillchar(PZ,sizeof(PZ),0);

// Lesen
    BlockRead(f1,istart,4);
    Blockread(f1,PS.sNR,imaxPlen);
    Blockread(f1,PS.iCode,4);
    BlockRead(f1,PS.iZiele,4);
    if (PS.icode>100000) then
    begin
      Showmessage('Dateiformat '+AktFilename+' ist nicht Ver. 1');
      exit;
    end;
    BlockRead(f1,PS.dLuftdruck,SizeOf(Double));
    BlockRead(f1,PS.dTemperatur,SizeOf(double));
    BlockRead(f1,PS.dFernrohr,SizeOf(double));
    BlockRead(f1,PS.dEDM,SizeOf(double));
    BlockRead(f1,PS.sBem,iBemLen);
    BlockRead(f1,PS.iTag,4);
    BlockRead(f1,PS.iMonat,4);
    Blockread(f1,PS.iJahr,4);
    BlockRead(f1,PS.dZeit,SizeOf(Double));

    For i:=1 To PS.iZiele do
    begin
      BlockRead(f1,PZ[i].sNr,iMaxPlen);
      BlockRead(f1,PZ[i].iCode,4);
      BlockRead(f1,PZ[i].dTafel,SizeOf(Double));
      BlockRead(f1,PZ[i].dReflektor,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz0,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz1,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz2,SizeOf(Double));
      BlockRead(f1,PZ[i].dStrecke,SizeOf(Double));
      BlockRead(f1,PZ[i].dSeitw,SizeOf(Double));
      BlockRead(f1,PZ[i].dDH,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD0,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD1,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD2,SizeOf(Double));
      PZ[i].dEDMNR:=630945.01;
      BlockRead(f1,PZ[i].dDist,SizeOf(Double));
      BlockRead(f1,PZ[i].dExz,SizeOf(Double));
      BlockRead(f1,PZ[i].lDI,SizeOf(Boolean));
      BlockRead(f1,PZ[i].sBem,iBemLen);
    end;
    form1.statusbar1.simpletext:=PS.snr;
// Schreiben
    PosStart:=Filepos(f2);
    BlockWrite(f2,Posstart,4);
    BlockWrite(f2,PS.sNR,imaxPlen);
    iVer:=iVersion*1000;
    BlockWrite(f2,iVer,4); //201000 damit nochmalige konvertierung verhindert wird
    BlockWrite(f2,PS.iCode,4);
    BlockWrite(f2,PS.iZiele,4);
    BlockWrite(f2,PS.dLuftdruck,SizeOf(Double));
    BlockWrite(f2,PS.dTemperatur,SizeOf(double));
    BlockWrite(f2,PS.dFernrohr,SizeOf(double));
    BlockWrite(f2,PS.dEDM,SizeOf(double));
    BlockWrite(f2,PS.sBem,iBemLen);
    BlockWrite(f2,PS.iTag,4);
    BlockWrite(f2,PS.iMonat,4);
    BlockWrite(f2,PS.iJahr,4);
    BlockWrite(f2,PS.dZeit,SizeOf(Double));
    For i:=1 To PS.iZiele do
    begin
      BlockWrite(f2,PZ[i].sNr,iMaxPlen);
      BlockWrite(f2,PZ[i].iCode,4);
      BlockWrite(f2,PZ[i].dTafel,SizeOf(Double));
      BlockWrite(f2,PZ[i].dReflektor,SizeOf(Double));
      BlockWrite(f2,PZ[i].dHz0,SizeOf(Double));
      BlockWrite(f2,PZ[i].dHz1,SizeOf(Double));
      BlockWrite(f2,PZ[i].dHz2,SizeOf(Double));
      BlockWrite(f2,PZ[i].dStrecke,SizeOf(Double));
      BlockWrite(f2,PZ[i].dSeitw,SizeOf(Double));
      BlockWrite(f2,PZ[i].dDH,SizeOf(Double));
      BlockWrite(f2,PZ[i].dZD0,SizeOf(Double));
      BlockWrite(f2,PZ[i].dZD1,SizeOf(Double));
      BlockWrite(f2,PZ[i].dZD2,SizeOf(Double));
      BlockWrite(f2,PZ[i].dEDMNR,SizeOf(Double));
      BlockWrite(f2,PZ[i].dDist,SizeOf(Double));
      BlockWrite(f2,PZ[i].dExz,SizeOf(Double));
      BlockWrite(f2,PZ[i].lDI,SizeOf(Boolean));
      BlockWrite(f2,PZ[i].sBem,iBemLen);
    end;
    PosEnd:=FilePos(f2);
    Seek(f2,Posstart);
    Posend:=posend+1; // In Geobasic beginnt die Datei mit Index 1 und nicht mit 0
    BlockWrite(f2,Posend,4);
    Seek(f2,PosEnd-1);
  end;

  Closefile(f1);
  CloseFile(f2);
  if (MessageDLG('Datei '+s+' erzeugt in '+AktFilename+' umbennen?',mtConfirmation, [mbYes, mbNo], 0) = mrYes)  then
  begin
    DeleteFile(AktFilename);
    Renamefile(s,AktFilename);
  end;
end;

procedure Tform1.BuildPIndex;
var f1:file;
   iRec,iStart:LongWord;
   i:Integer;
   sNr:Array[1..iMaxPlen] of Char;
begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  iRec:=0;
  for i:=0 to ComboboxPS.Items.Count-1 do ComboBoxPS.Items.Objects[i]:=NIL;
  ComboBoxPS.Items.Clear;
  repeat
    seek(f1,iRec);
    BlockRead(f1,istart,4);
    Blockread(f1,sNR,imaxPlen);
    ComboBoxPS.AddItem(StrPas(@sNR),Tobject(iRec));
    irec:=iStart-1;
  until irec>=Filesize(f1);
  closefile(f1);
  if ComboboxPS.Items.Count>0 then ComboBoxPS.ItemIndex:=0
  else ComboBoxPS.Itemindex:=-1;
end;

procedure Tform1.BuildZPIndex;
var f1:file;
   iRec,iStart:LongWord;
   i:Integer;
   sNr:Array[1..iMaxPlen] of Char;
   PS:TStandpunkt;
   PZ:TZielpunkte;
begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  iRec:=0;
  for i:=0 to ComboboxZP.Items.Count-1 do ComboBoxZP.Items.Objects[i]:=NIL;
  ComboBoxZP.Items.Clear;
  repeat
    Fillchar(PS,sizeof(PS),0);
    Fillchar(PZ,sizeof(PZ),0);
    seek(f1,iRec);
    BlockRead(f1,istart,4);
    Blockread(f1,PS.sNR,imaxPlen);
    BlockRead(f1,iVer,4);
    Blockread(f1,PS.iCode,4);
    BlockRead(f1,PS.iZiele,4);
    BlockRead(f1,PS.dLuftdruck,SizeOf(Double));
    BlockRead(f1,PS.dTemperatur,SizeOf(double));
    BlockRead(f1,PS.dFernrohr,SizeOf(double));
    BlockRead(f1,PS.dEDM,SizeOf(double));
    BlockRead(f1,PS.sBem,iBemLen);
    BlockRead(f1,PS.iTag,4);
    BlockRead(f1,PS.iMonat,4);
    Blockread(f1,PS.iJahr,4);
    BlockRead(f1,PS.dZeit,SizeOf(Double));
    For i:=1 To PS.iZiele do
    begin
      BlockRead(f1,PZ[i].sNr,iMaxPlen);
      BlockRead(f1,PZ[i].iCode,4);
      BlockRead(f1,PZ[i].dTafel,SizeOf(Double));
      BlockRead(f1,PZ[i].dReflektor,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz0,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz1,SizeOf(Double));
      BlockRead(f1,PZ[i].dHz2,SizeOf(Double));
      BlockRead(f1,PZ[i].dStrecke,SizeOf(Double));
      BlockRead(f1,PZ[i].dSeitw,SizeOf(Double));
      BlockRead(f1,PZ[i].dDH,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD0,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD1,SizeOf(Double));
      BlockRead(f1,PZ[i].dZD2,SizeOf(Double));
      BlockRead(f1,PZ[i].dEDMNR,SizeOf(Double));
      BlockRead(f1,PZ[i].dDist,SizeOf(Double));
      BlockRead(f1,PZ[i].dExz,SizeOf(Double));
      BlockRead(f1,PZ[i].lDI,SizeOf(Boolean));
      BlockRead(f1,PZ[i].sBem,iBemLen);
      ComboBoxZP.AddItem(StrPas(@PZ[i].sNR),Tobject(iRec));
    end;
    irec:=iStart-1;
  until irec>=Filesize(f1);
  closefile(f1);
  if ComboboxZP.Items.Count>0 then ComboBoxZP.ItemIndex:=0
  else ComboBoxZP.Itemindex:=-1;
end;

Procedure TForm1.LiesStandpunkt(iRec:LongWord);
var f1:File;
    iStart:LongWord;
    i:Integer;
begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  seek(f1,irec);
  Fillchar(PS,sizeof(PS),0);
  Fillchar(PZ,sizeof(PZ),0);

  BlockRead(f1,istart,4);
  Blockread(f1,PS.sNR,imaxPlen);
  BlockRead(f1,iVer,4);
  Blockread(f1,PS.iCode,4);
  BlockRead(f1,PS.iZiele,4);
  BlockRead(f1,PS.dLuftdruck,SizeOf(Double));
  BlockRead(f1,PS.dTemperatur,SizeOf(double));
  BlockRead(f1,PS.dFernrohr,SizeOf(double));
  BlockRead(f1,PS.dEDM,SizeOf(double));
  BlockRead(f1,PS.sBem,iBemLen);
  BlockRead(f1,PS.iTag,4);
  BlockRead(f1,PS.iMonat,4);
  Blockread(f1,PS.iJahr,4);
  BlockRead(f1,PS.dZeit,SizeOf(Double));
  For i:=1 To PS.iZiele do
  begin
    BlockRead(f1,PZ[i].sNr,iMaxPlen);
    BlockRead(f1,PZ[i].iCode,4);
    BlockRead(f1,PZ[i].dTafel,SizeOf(Double));
    BlockRead(f1,PZ[i].dReflektor,SizeOf(Double));
    BlockRead(f1,PZ[i].dHz0,SizeOf(Double));
    BlockRead(f1,PZ[i].dHz1,SizeOf(Double));
    BlockRead(f1,PZ[i].dHz2,SizeOf(Double));
    BlockRead(f1,PZ[i].dStrecke,SizeOf(Double));
    BlockRead(f1,PZ[i].dSeitw,SizeOf(Double));
    BlockRead(f1,PZ[i].dDH,SizeOf(Double));
    BlockRead(f1,PZ[i].dZD0,SizeOf(Double));
    BlockRead(f1,PZ[i].dZD1,SizeOf(Double));
    BlockRead(f1,PZ[i].dZD2,SizeOf(Double));
    BlockRead(f1,PZ[i].dEDMNR,SizeOf(Double));
    BlockRead(f1,PZ[i].dDist,SizeOf(Double));
    BlockRead(f1,PZ[i].dExz,SizeOf(Double));
    BlockRead(f1,PZ[i].lDI,SizeOf(Boolean));
    BlockRead(f1,PZ[i].sBem,iBemLen);
  end;
  Richtungsmittel(PS,PZ);
  Zenitdistanzmittel(PS,PZ);
  Modified:=false;
  DisplayData;
  // Wichtig wegen Zugriff ber Zielpunktnummer
  ComboBoxPS.ItemIndex:=ComboBoxPS.Items.IndexOfObject(TObject(irec))
end;

procedure TForm1.ComboBoxPSSelect(Sender: TObject);
begin
  LiesStandpunkt(integer(ComboBoxPS.Items.Objects[ComboBoxPS.ItemIndex]));
  statusbar1.SimpleText:=format('Standpunkt %d von %d',[ComboBoxPS.ItemIndex+1,ComboBoxPS.Items.Count]);
  Statusbar1.Update;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  Opendialog1.Title:='Beobachtungsdatei auswhlen';
  If Opendialog1.execute then
  begin
    Screen.Cursor:=crHourGlass;
    AktFilename:=OpenDialog1.Filename;
    Form1.Caption:=Format('TRIGMESSEdit Ver. %5.2f Datei: '+AktFilename,[iVersion/100]);
    BuildPIndex;
    DisplayData;
    ComboBoxPS.ItemIndex:=0;
    ComboBoxPSSelect(Sender);
    Screen.Cursor:=crDefault;
    ToolButton2.Enabled:=True;
    ToolButton3.Enabled:=True;
    ToolButton6.Enabled:=True;
    ToolButton7.Enabled:=True;
    ToolButton8.Enabled:=True;
    ToolButton9.Enabled:=True;
    ToolButton10.Enabled:=True;
    ToolButton11.Enabled:=True;
    ToolButton12.Enabled:=True;
    BuildZPIndex;
  end;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  If AktFilename<>'' then
  begin
    Screen.Cursor:=crHourGlass;
    TrigmessInBEB;
    Screen.Cursor:=crDefault;
  end;
{
  If Opendialog1.execute then
  begin
    Screen.Cursor:=crHourGlass;
    AktFileName:=OpenDialog1.FileName;
    TrigmessInBEB;
    Screen.Cursor:=crDefault;
  end;
}
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  Opendialog1.Title:='Messdatenfile auswhlen';
  Opendialog1.Filter:='TRIGMESS Messdaten|*.BIN';
  If Opendialog1.execute then
  begin
    Screen.Cursor:=crHourGlass;
    AktFileName:=OpenDialog1.Filename;
    ModifyTrigmessbin;
    Screen.Cursor:=crDefault;
    Close;
  end;
end;

procedure TForm1.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  with StringGrid1 do
  begin
    if (Arow>0) and not DataLocked then
    begin
      case Acol of
      0:begin
          StrPCopy(@PZ[Arow].sNr,Cells[0,Arow]);
          Modified:=true;
        end;
      1:begin
          PZ[Arow].iCode:=StrTointDef(Cells[1,Arow],0);
          Modified:=true;
        end;
      2:begin
          PZ[Arow].dHz0:=StrToFloatDef(Cells[2,Arow],0);
          Modified:=true;
        end;
      3:begin
          PZ[Arow].dStrecke:=StrToFloatDef(Cells[3,Arow],0);
          Modified:=true;
        end;
      4:begin
          PZ[Arow].dDH:=StrToFloatDef(Cells[4,Arow],0);
          Modified:=true;
        end;
      5:begin
          PZ[Arow].dZD0:=StrToFloatDef(Cells[5,Arow],0);
          Modified:=true;
        end;
      6:begin
          PZ[Arow].dTafel:=StrToFloatDef(Cells[6,Arow],0);
          Modified:=true;
        end;
      7:begin
          PZ[Arow].dReflektor:=StrToFloatDef(Cells[7,Arow],0);
          Modified:=true;
        end;
      8:begin
          PZ[Arow].dDist:=StrToFloatDef(Cells[8,Arow],0);
          Modified:=true;
        end;
      9:begin
          PZ[Arow].dExz:=StrToFloatDef(Cells[9,Arow],0);
          Modified:=true;
        end;
      10:begin
          PZ[Arow].dSeitw:=StrToFloatDef(Cells[10,Arow],0);
          Modified:=true;
        end;
      11:begin
          PZ[Arow].dEDMNR:=StrToFloatDef(Cells[11,Arow],0);
          Modified:=true;
        end;
      12:begin
          PZ[Arow].dHz1:=StrToFloatDef(Cells[12,Arow],0);
          Modified:=true;
        end;
      13:begin
          PZ[Arow].dHz2:=StrToFloatDef(Cells[13,Arow],0);
          Modified:=true;
        end;
      14:begin
          PZ[Arow].dZD1:=StrToFloatDef(Cells[14,Arow],0);
          Modified:=true;
        end;
      15:begin
          PZ[Arow].dZD2:=StrToFloatDef(Cells[15,Arow],0);
          Modified:=true;
        end;
      16:begin
          StrPCopy(@PZ[Arow].sBem,Cells[16,Arow]);
          Modified:=true;
        end;
      end;
    end;
  end;
end;


procedure TForm1.ToolButton5Click(Sender: TObject);
begin
  If Toolbutton5.Down then
  begin
    DataLocked:=False;
    StringgRid1.Font.Color:=clRed;
    StringGrid1.Options:=StringGrid1.Options+[goEditing];
    Toolbutton5.ImageIndex:=4;

    EditPS.ReadOnly:=false;
    EditPSCode.ReadOnly:=false;
    EditPSDruck.ReadOnly:=false;
    EditPSTemp.ReadOnly:=false;
    EditFernrohr.ReadOnly:=false;
    EditEDM.ReadOnly:=false;
    EditPSbem.ReadOnly:=False;

    EditPS.Font.Color:=clRed;
    EditPSCode.Font.Color:=clRed;
    EditPSDruck.Font.Color:=clRed;
    EditPSTemp.Font.Color:=clRed;
    EditFernrohr.Font.Color:=clRed;
    EditEDM.Font.Color:=clRed;
    EditPSbem.Font.Color:=clRed;
  end
  else
  begin
    DataLocked:=True;
    StringgRid1.Font.Color:=clWindowText;
    StringGrid1.Options:=StringGrid1.Options-[goEditing];
    Toolbutton5.ImageIndex:=5;

    EditPS.ReadOnly:=True;
    EditPSCode.ReadOnly:=True;
    EditPSDruck.ReadOnly:=True;
    EditPSTemp.ReadOnly:=True;
    EditFernrohr.ReadOnly:=True;
    EditEDM.ReadOnly:=True;
    EditPSbem.ReadOnly:=True;

    EditPS.Font.Color:=clWindowText;
    EditPSCode.Font.Color:=clWindowText;
    EditPSDruck.Font.Color:=clWindowText;
    EditPSTemp.Font.Color:=clWindowText;
    EditFernrohr.Font.Color:=clWindowText;
    EditEDM.Font.Color:=clWindowText;
    EditPSbem.Font.Color:=clWindowText;
  end;
end;

procedure TForm1.EditPSCodeChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    PS.iCode:=StrTointDef(EditPSCode.Text,0);
    Modified:=true;
  end;
end;

procedure TForm1.EditPSDruckChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    PS.dLuftDruck:=StrToFloatDef(EditPSDruck.Text,0);
    Modified:=true;
  end;
end;

procedure TForm1.EditPSTempChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    PS.dTemperatur:=StrToFloatDef(EditPSTemp.Text,0);
    Modified:=true;
  end;

end;

procedure TForm1.EditFernrohrChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    PS.dFernrohr:=StrToFloatDef(EditFernrohr.Text,0);
    Modified:=true;
  end;

end;

procedure TForm1.EditEDMChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    PS.dEDM:=StrToFloatDef(EditEDM.Text,0);
    Modified:=true;
  end;

end;

procedure TForm1.EditPSBemChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    StrPCopy(@PS.sBem,EditPSBem.text);
    Modified:=true;
  end;

end;

procedure TForm1.ToolButton6Click(Sender: TObject);
begin
  if modified then
  begin
    SchreibTrigmess(integer(ComboBoxPS.Items.Objects[ComboBoxPS.ItemIndex]));
    BuildZPIndex;

  end;
end;

procedure TForm1.EditPSChange(Sender: TObject);
begin
  if not DataLocked then
  begin
    StrPCopy(@PS.sNr,EditPS.Text);
    Modified:=true;
  end;

end;

procedure TForm1.EinfuegenClick(Sender: TObject);
begin
  if not DataLocked then
  begin
    Stringgrid1.RowCount:=Stringgrid1.RowCount+1;
    StringGrid1.Rows[Stringgrid1.RowCount-1].Clear;
    StringGrid1.Update;
    Modified:=True;
  end;
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
begin
  if not dataLocked and (MessageDLG('Standpunkt lschen',mtConfirmation, [mbYes, mbNo], 0) = mrYes)  then
  begin
    DeleteStandpunkt(integer(ComboBoxPS.Items.Objects[ComboBoxPS.ItemIndex]));
    BuildPIndex;
    ComboboxPSSelect(sender);
  end;
end;

procedure TForm1.LoeschenClick(Sender: TObject);
var i:integer;
begin
  if not DataLocked and (MessageDLG(Format('Zielpunkt %-s lschen',[StringGrid1.Cells[0,Aktrow]]),mtConfirmation, [mbYes, mbNo], 0) = mrYes)  then
  begin
    for i:=Aktrow+1 to StringGrid1.RowCount-1 do
    begin
      StringGrid1.rows[i-1]:=StringGrid1.Rows[i];
      PZ[i-1]:=PZ[i];
    end;
    StringGrid1.RowCount:=StringGrid1.RowCount-1;
    Modified:=True;
    SchreibTrigmess(integer(ComboBoxPS.Items.Objects[ComboBoxPS.ItemIndex]));
  end;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
  AktRow:=ARow;
  AktCol:=ACol;
end;

procedure TForm1.StringGrid1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  If not DataLocked then
  begin
    if Shift=[ssCtrl] then
    case Key of
    VK_Insert:EinfuegenClick(sender);
    VK_Delete:LoeschenClick(sender);
    end;
  end;
end;

procedure TForm1.ToolButton8Click(Sender: TObject);
begin
  if ComboboxPS.Items.Count>0 then ComboBoxPS.ItemIndex:=0
  else ComboBoxPS.Itemindex:=-1;
  ComboboxPSSelect(sender);
end;

procedure TForm1.ToolButton11Click(Sender: TObject);
begin
  if ComboboxPS.Items.Count>0 then ComboBoxPS.Itemindex:=ComboBoxPS.Items.Count-1
  else ComboBoxPS.Itemindex:=-1;
  ComboboxPSSelect(sender);
end;

procedure TForm1.ToolButton9Click(Sender: TObject);
begin
  if ComboboxPS.Items.Count>0 then
  begin
    if ComboBoxPS.ItemIndex<ComboBoxPS.Items.count-1 then ComboBoxPS.Itemindex:=ComboBoxPS.ItemIndex+1
    else
    begin
       Beep;
       Showmessage('Letzter Standpunkt');
       //ComboBoxPS.ItemIndex:=0;
    end;
  end
  else ComboBoxPS.Itemindex:=-1;
  ComboboxPSSelect(sender);

end;

procedure TForm1.ToolButton10Click(Sender: TObject);
begin
  if ComboboxPS.Items.Count>0 then
  begin
    if ComboBoxPS.ItemIndex>0 then ComboBoxPS.Itemindex:=ComboBoxPS.ItemIndex-1
    else
    begin
       Beep;
       Showmessage('Erster Standpunkt');
       //ComboBoxPS.ItemIndex:=ComboBoxPS.Items.Count-1;
    end;
  end
  else ComboBoxPS.Itemindex:=-1;
  ComboboxPSSelect(sender);

end;


procedure TForm1.ToolButton12Click(Sender: TObject);
begin
  If not DataLocked and (Aktrow>0) and (PZ[AktRow].dZD1>0) and (PZ[aktrow].dZD2>0) then
  begin
    KnopfTafelhoehe(StrPas(@PZ[AktRow].sNr));
  end;
end;

procedure TForm1.Memo1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case key of
  VK_ESCAPE:
    begin
      Memo1.Clear;
      Memo1.Hide;
      GroupBox3.Hide;
    end;
  end;
end;

procedure TForm1.GroupBox3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   TWincontrol(sender).perform(WM_LBUTTONUP, 0, 0);
   TWincontrol(sender).Perform(WM_SysCommand,SC_MOVE+2,2);
end;

Procedure Tform1.Knopftafelhoehe(PNR:String);
type
    SPIdxTyp=Record
      SPNR:Array[1..ImaxPlen] of Char;
      SPI:LongWord;
      RIKN:Double;
      DeltaKn:Double;
      ZPKnopf:Integer;
      ZPI:Array of integer;
      RI:Array of Double;
      ST:Array of Double;
    end;

var j,i,n,iMax,jMax:Integer;
    f1:File;
    f:Textfile;
    PSP:TStandpunkt;
    PZP:TZielpunkte;
    SPIdx:array of SPIdxTyp;
    Alfa,Beta,Gamma,GammaMax,a,b,c,ra,rb,r,T:Double;

Procedure LiesPSP(iRec:LongWord);
var
    iStart:LongWord;
    i:Integer;
begin
  seek(f1,irec);
  Fillchar(PSP,sizeof(PS),0);
  Fillchar(PZP,sizeof(PZ),0);

  BlockRead(f1,istart,4);
  Blockread(f1,PSP.sNR,imaxPlen);
  BlockRead(f1,iVer,4);
  Blockread(f1,PSP.iCode,4);
  BlockRead(f1,PSP.iZiele,4);
  BlockRead(f1,PSP.dLuftdruck,SizeOf(Double));
  BlockRead(f1,PSP.dTemperatur,SizeOf(double));
  BlockRead(f1,PSP.dFernrohr,SizeOf(double));
  BlockRead(f1,PSP.dEDM,SizeOf(double));
  BlockRead(f1,PSP.sBem,iBemLen);
  BlockRead(f1,PSP.iTag,4);
  BlockRead(f1,PSP.iMonat,4);
  Blockread(f1,PSP.iJahr,4);
  BlockRead(f1,PSP.dZeit,SizeOf(Double));
  For i:=1 To PSP.iZiele do
  begin
    BlockRead(f1,PZP[i].sNr,iMaxPlen);
    BlockRead(f1,PZP[i].iCode,4);
    BlockRead(f1,PZP[i].dTafel,SizeOf(Double));
    BlockRead(f1,PZP[i].dReflektor,SizeOf(Double));
    BlockRead(f1,PZP[i].dHz0,SizeOf(Double));
    BlockRead(f1,PZP[i].dHz1,SizeOf(Double));
    BlockRead(f1,PZP[i].dHz2,SizeOf(Double));
    BlockRead(f1,PZP[i].dStrecke,SizeOf(Double));
    BlockRead(f1,PZP[i].dSeitw,SizeOf(Double));
    BlockRead(f1,PZP[i].dDH,SizeOf(Double));
    BlockRead(f1,PZP[i].dZD0,SizeOf(Double));
    BlockRead(f1,PZP[i].dZD1,SizeOf(Double));
    BlockRead(f1,PZP[i].dZD2,SizeOf(Double));
    BlockRead(f1,PZP[i].dEDMNR,SizeOf(Double));
    BlockRead(f1,PZP[i].dDist,SizeOf(Double));
    BlockRead(f1,PZP[i].dExz,SizeOf(Double));
    BlockRead(f1,PZP[i].lDI,SizeOf(Boolean));
    BlockRead(f1,PZP[i].sBem,iBemLen);
  end;
  Richtungsmittel(PSP,PZP);
  ZenitdistanzMittel(PSP,PZP);
end;

procedure SchreibPSP(iStart:LongWord);
var i:Integer;
    iEnd:LongWord;
begin
  seek(f1,iStart+4);
  BlockWrite(f1,PSP.sNR,imaxPlen);
  BlockWrite(f1,iVer,4); //201000 damit nochmalige konvertierung verhindert wird
  BlockWrite(f1,PSP.iCode,4);
  BlockWrite(f1,PSP.iZiele,4);
  BlockWrite(f1,PSP.dLuftdruck,SizeOf(Double));
  BlockWrite(f1,PSP.dTemperatur,SizeOf(double));
  BlockWrite(f1,PSP.dFernrohr,SizeOf(double));
  BlockWrite(f1,PSP.dEDM,SizeOf(double));
  BlockWrite(f1,PSP.sBem,iBemLen);
  BlockWrite(f1,PSP.iTag,4);
  BlockWrite(f1,PSP.iMonat,4);
  BlockWrite(f1,PSP.iJahr,4);
  BlockWrite(f1,PSP.dZeit,SizeOf(Double));
  For i:=1 To PSP.iZiele do
  begin
    BlockWrite(f1,PZP[i].sNr,iMaxPlen);
    BlockWrite(f1,PZP[i].iCode,4);
    BlockWrite(f1,PZP[i].dTafel,SizeOf(Double));
    BlockWrite(f1,PZP[i].dReflektor,SizeOf(Double));
    BlockWrite(f1,PZP[i].dHz0,SizeOf(Double));
    BlockWrite(f1,PZP[i].dHz1,SizeOf(Double));
    BlockWrite(f1,PZP[i].dHz2,SizeOf(Double));
    BlockWrite(f1,PZP[i].dStrecke,SizeOf(Double));
    BlockWrite(f1,PZP[i].dSeitw,SizeOf(Double));
    BlockWrite(f1,PZP[i].dDH,SizeOf(Double));
    BlockWrite(f1,PZP[i].dZD0,SizeOf(Double));
    BlockWrite(f1,PZP[i].dZD1,SizeOf(Double));
    BlockWrite(f1,PZP[i].dZD2,SizeOf(Double));
    BlockWrite(f1,PZP[i].dEDMNR,SizeOf(Double));
    BlockWrite(f1,PZP[i].dDist,SizeOf(Double));
    BlockWrite(f1,PZP[i].dExz,SizeOf(Double));
    BlockWrite(f1,PZP[i].lDI,SizeOf(Boolean));
    BlockWrite(f1,PZP[i].sBem,iBemLen);
  end;
  iEnd:=FilePos(f1);
  Seek(f1,iStart);
  iEnd:=iEnd+1;  // In GeoBasic hat das erste Byte den Index 1 und nicht 0 wie hier
  BlockWrite(f1,iEnd,4);
  Seek(f1,iEnd-1);
end;

procedure SuchBeobachtungen;
var i,j,k:integer;
    PsIdx:LongWord;
begin
  Setlength(SPIdx,0);
  for i:=0 to ComboBoxPS.Items.Count-1 do
  begin
    PSIdx:=integer(ComboBoxPS.items.Objects[i]);
    LiesPSP(PSIdx);
    for j:=1 to PSP.iZiele do
    begin
      If (StrPas(@PZP[j].sNr)=PNR) and (abs(PZP[j].dHZ2-PZP[j].dHZ1+200)>0.005) then
      begin
        setlength(SPIdx,length(SPIdx)+1);
        SPIdx[High(SPIdx)].SPI:=PSidx;
        SPIdx[High(SPIdx)].ZPKnopf:=j;
        SPIdx[High(SPIdx)].RIKN:=PZP[j].dHz0;
        SPIdx[High(SPIdx)].DeltaKN:=abs(PZP[j].dHz2-PZP[j].dHZ1+200);
        if SPIdx[High(SPIdx)].DeltaKN>200 then
          SPIdx[High(SPIdx)].DeltaKN:=SPIdx[High(SPIdx)].DeltaKN-400;
        SPIdx[High(SPIdx)].DeltaKN:=Abs(SPIdx[High(SPIdx)].DeltaKN);
        System.Ansistrings.strcopy(@SPIdx[High(SPIdx)].SPNr,@PSP.sNr);
      end;
    end;
  end;

  for i:=0 to high(SPIDx) do
  begin
    setlength(SPIdx[i].ZPI,length(SPIdx));
    setlength(SPIdx[i].RI,length(SPIdx));
    setlength(SPIdx[i].ST,length(SPIdx));
    for k:=0 to High(SPIdx) do
    begin
      LiesPSP(SPIdx[k].SPI);
      for j:=1 to PSP.iZiele do
        If SPIdx[i].SPNR=PZP[j].sNr then
        begin
          Spidx[i].ZPI[k]:=j;
          SpIdx[i].RI[k]:=PZP[j].dHz0;
          SpIdx[i].ST[k]:=sin(PZP[j].dZD0/dRhoG)*PZP[j].dDist+PZP[j].dExz;
        end;
    end;
  end;
end;

begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  SuchBeobachtungen;
  Alfa:=0;Beta:=0;n:=0;R:=0;
  Memo1.Clear;
  imax:=0;jmax:=0;gammamax:=0;
  Memo1.lines.Clear;
  GroupBox3.Caption:='Tafelhhenkorrektur';
  for i:=0 to high(SPIdx) do
  begin
    for j:=0 to High(SPidx) do
      if SPIdx[i].ZPI[j]>0 then
      begin
        Beta:=SPIdx[j].RI[i]-SPidx[i].RIKN;
        Alfa:=SPIdx[i].RI[j]-SPIdx[j].RIKN;
        if Alfa<0 then alfa:=-Alfa;
        If Alfa>200 then Alfa:=400-Alfa;
        if Beta<0 then Beta:=-Beta;
        If Beta>200 then Beta:=400-Beta;
        Gamma:=200-Alfa-Beta;
        if Gamma>GammaMax then
        begin
          GammaMax:=gamma;
          iMax:=i;jMax:=j;
        end;
        c:=SPIdx[i].ST[j];
        a:=sin(alfa/dRhoG)/sin(Gamma/dRhoG)*c;
        b:=sin(Beta/dRhoG)/sin(Gamma/dRhoG)*c;
        ra:=a*sin(Spidx[i].DeltaKn/2/dRhoG);
        rb:=b*sin(Spidx[j].DeltaKn/2/dRhoG);
        if (abs(SPidx[i].DeltaKN)>0.01) and (abs(SPidx[i].DeltaKN)>0.01) then
        begin
          If abs(ra-rb)<0.03 then R:=(ra+rb)/2
          else
            if ra>rb then R:=ra
            else
              If rb>0 then R:=rb;

          Memo1.Lines.add('Tafelhhenkorrektur in '+PNR);
          memo1.Lines.add(Format('Punkt A %-16s a %8.3f m Alfa  %8.4f gon Radius=%6.3f m',[StrPas(@SPIdx[j].SPNR),a,Alfa,ra]));
          memo1.Lines.add(Format('Punkt B %-16s b %8.3f m Beta  %8.4f gon Radius=%6.3f m',[StrPas(@SPIdx[i].SPNR),b,Beta,rb]));
          memo1.Lines.add(Format('Punkt C %-16s c %8.3f m Gamma %8.4f gon Mittel=%6.3f m',[PNR,c,Gamma,r]));
        end;
      end;
  end;

  for i:=0 to high(SPidx) do
  begin
    LiesPSP(SPIdx[i].SPI);
    If PZP[SPIdx[i].ZPKnopf].dZD0>0 then
    begin
      T:=R*cot(PZP[SPIdx[i].ZPKnopf].dZD0/dRhoG);
      if T>0 then Memo1.Lines.add(Format('Tafelhhe in %-16s T %7.3f',[StrPas(@PSP.sNR),T]));
    end;
  end;
  GroupBox3.Show;
  Memo1.show;

  if MessageDLG('Tafelhhenkorrektur anbringen',mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
    for i:=0 to high(SPidx) do
    begin
      LiesPSP(SPIdx[i].SPI);
      If PZP[SPIdx[i].ZPKnopf].dZD0>0 then
      begin
        PZP[SPIdx[i].ZPKnopf].dTafel:=R*cot(PZP[SPIdx[i].ZPKnopf].dZD0/dRhoG);
        if PZP[SPIdx[i].ZPKnopf].dTafel<0 then PZP[SPIdx[i].ZPKnopf].dTafel:=0;
        SchreibPSP(SPIdx[i].SPI);
      end;
    end;
    assignfile(f,leftStr(AktFilename,Length(AktFilename)-3)+'KNH');
    {$I-}
    append(f);
    If IOResult<>0 then rewrite(f);
    {$I+}
    writeln(f,Format('TRIGMESSEdit Ver. %5.2f',[iVersion/100]));
    for i:=0 to memo1.lines.Count-1 do writeln(f,Memo1.lines.strings[i]);
    closefile(f);
  end;
  Closefile(f1);
  Memo1.SetFocus;
end;

procedure TForm1.CheckDoppelmessungen(SEnder:TObject);
var i,j,k,k1,k2,nOri:Integer;
    f1:File;
    f:Textfile;
    PS1,PS2:TStandpunkt;
    PZ1,PZ2:TZielpunkte;
    Ori:Double;

Procedure LiesPSP(iRec:LongWord;Var PSP:TStandpunkt; Var PZP:TZielpunkte);
var
    iStart:LongWord;
    i:Integer;
begin
  seek(f1,irec);
  Fillchar(PSP,sizeof(PS),0);
  Fillchar(PZP,sizeof(PZ),0);

  BlockRead(f1,istart,4);
  Blockread(f1,PSP.sNR,imaxPlen);
  BlockRead(f1,iVer,4);
  Blockread(f1,PSP.iCode,4);
  BlockRead(f1,PSP.iZiele,4);
  BlockRead(f1,PSP.dLuftdruck,SizeOf(Double));
  BlockRead(f1,PSP.dTemperatur,SizeOf(double));
  BlockRead(f1,PSP.dFernrohr,SizeOf(double));
  BlockRead(f1,PSP.dEDM,SizeOf(double));
  BlockRead(f1,PSP.sBem,iBemLen);
  BlockRead(f1,PSP.iTag,4);
  BlockRead(f1,PSP.iMonat,4);
  Blockread(f1,PSP.iJahr,4);
  BlockRead(f1,PSP.dZeit,SizeOf(Double));
  For i:=1 To PSP.iZiele do
  begin
    BlockRead(f1,PZP[i].sNr,iMaxPlen);
    BlockRead(f1,PZP[i].iCode,4);
    BlockRead(f1,PZP[i].dTafel,SizeOf(Double));
    BlockRead(f1,PZP[i].dReflektor,SizeOf(Double));
    BlockRead(f1,PZP[i].dHz0,SizeOf(Double));
    BlockRead(f1,PZP[i].dHz1,SizeOf(Double));
    BlockRead(f1,PZP[i].dHz2,SizeOf(Double));
    BlockRead(f1,PZP[i].dStrecke,SizeOf(Double));
    BlockRead(f1,PZP[i].dSeitw,SizeOf(Double));
    BlockRead(f1,PZP[i].dDH,SizeOf(Double));
    BlockRead(f1,PZP[i].dZD0,SizeOf(Double));
    BlockRead(f1,PZP[i].dZD1,SizeOf(Double));
    BlockRead(f1,PZP[i].dZD2,SizeOf(Double));
    BlockRead(f1,PZP[i].dEDMNR,SizeOf(Double));
    BlockRead(f1,PZP[i].dDist,SizeOf(Double));
    BlockRead(f1,PZP[i].dExz,SizeOf(Double));
    BlockRead(f1,PZP[i].lDI,SizeOf(Boolean));
    BlockRead(f1,PZP[i].sBem,iBemLen);
    If PZP[i].dDist>0 Then
      PZP[i].ddH:=PZP[i].dDist*Cos(PZP[i].dZD0/dRhoG)+PSP.dFernrohr-PZP[i].dTafel;
  end;
  Richtungsmittel(PSP,PZP);
  ZenitdistanzMittel(PSP,PZP);
end;

begin
  assignfile(f1,AktFileName);
  reset(f1,1);
  GroupBox3.Caption:='Messdatencheck';
  Memo1.Lines.Clear;
  for i:=0 to ComboboxPS.Items.Count-1 do
  begin
    LiesPSP(Integer(ComboboxPS.Items.Objects[i]),PS1,PZ1);
    for j:=i+1 to ComboboxPS.Items.Count-1 do
    begin
      if i<>j then
      begin
        LiesPSP(Integer(ComboboxPS.Items.Objects[j]),PS2,PZ2);
        If System.ansistrings.StrComp(@PS1.sNR,@PS2.sNR)=0 then // Gleiche Standpunktnummer
        begin
          // Satz 2 an Satz 1 orientieren und orientierungsunbekannte rechnen
          Ori:=0;nOri:=0;
          for k1:=1 to PS1.iZiele do
          begin
            for k2:=1 to PS2.iZiele do
              If System.ansistrings.StrComp(@PZ1[k1].sNr,@PZ2[k2].sNr)=0 then
              begin
                If (PZ1[k1].dHz0>0) and (PZ2[k2].dHz0>0) then
                begin
                  Ori:=Ori+PZ1[k1].dHz0-PZ2[k2].dHz0;
                  inc(nOri);
                end;
              end;
          end;
          if nOri>0 then Ori:=Ori/nOri else nOri:=0;

          for k1:=1 to PS1.iZiele do
          begin
            for k2:=1 to PS2.iZiele do
              If (System.ansistrings.StrComp(@PZ1[k1].sNr,@PZ2[k2].sNr)=0) and (Pos('SONNE',Strpas(@PZ1[k1].sBem))=0) then
              begin
                If (PZ1[k1].dDH<>0) and (PZ2[k2].dDH<>0) and (abs(abs(PZ1[k1].dDH)-abs(PZ2[k2].dDH))>MaxdH) then
                  Memo1.Lines.Add(Format('%-16s %-16s %9.3f %9.3f fdH  %9.3f',[StrPas(@PS1.sNR),StrPas(@PZ1[k1].sNr),PZ1[k1].dDH,PZ2[k2].dDH,abs(PZ1[k1].dDH-PZ2[k2].dDH)]));
                If (PZ1[k1].dDist>0) and (PZ2[k2].dDist>0) and (abs(PZ1[k1].dDist-PZ2[k2].dDist)>MaxDI) then
                  Memo1.Lines.Add(Format('%-16s %-16s %9.3f %9.3f fDist %9.3f',[StrPas(@PS1.sNR),StrPas(@PZ1[k1].sNr),PZ1[k1].dDist,PZ2[k2].dDIst,abs(PZ1[k1].dDIst-PZ2[k2].dDist)]));
                If abs(PZ1[k1].dHz0-(PZ2[k2].dHz0+Ori))>MaxHz then
                  Memo1.Lines.Add(Format('%-16s %-16s %9.4f %9.4f fHz0  %9.4f',[StrPas(@PS1.sNR),StrPas(@PZ1[k1].sNr),PZ1[k1].dHz0,PZ2[k2].dHz0,abs(PZ1[k1].dHz0-(PZ2[k2].dHz0+Ori))]));
                If (PZ1[k1].dzD0>0) and (PZ2[k2].dZD0>0) and (abs(PZ1[k1].dZD0-PZ2[k2].dZD0)>MaxZD) then
                  Memo1.Lines.Add(Format('%-16s %-16s %9.4f %9.4f fZD0  %9.4f',[StrPas(@PS1.sNR),StrPas(@PZ1[k1].sNr),PZ1[k1].dZD0,PZ2[k2].dZD0,abs(PZ1[k1].dZD0-PZ2[k2].dZD0)]));
              end;
          end;
        end;
      end;
    end;
  end;
  closefile(f1);
  GroupBox3.Show;
  Memo1.Show;
end;
procedure TForm1.Button1Click(Sender: TObject);
begin
  If ComboBoxPS.Sorted then
  begin
    ComboBoxPS.Sorted:=False;
    BuildPIndex;
  end
  else ComboBoxPS.Sorted:=True;
  ComboBoxPS.ItemIndex:=0;
  ComboBoxPSSelect(Sender);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Formatsettings.DecimalSeparator:='.';
  FormatSettings.ThousandSeparator:=',';
  iVersion:=202;
  DataLocked:=true;
  Modified:=False;
  Form1.Caption:=Format('TRIGMESSEdit Ver. %5.2f',[iVersion/100]);
  ReadIniFile;
end;

procedure Tform1.ImportTrigmessbin;
var
  f1,f2:file;
  iStart,iEnd,iver,n:LongWord;
  PSP:TStandpunkt;
  PZP:Array[1..iMaxZielp] of TZielpunkt;
  i:Integer;

begin
  Opendialog1.Title:='Anzuhngende Beobachtungsdatei auswhlen';
  if Opendialog1.Execute then
  begin
    assignfile(f1,AktFileName);
    reset(f1,1);
    iEnd:=FileSize(f1);
    AssignFile(f2,Opendialog1.FileName);
    reset(f2,1);
    n:=0;
    while not eof(f2) do
    begin
      Fillchar(PSP,sizeof(PS),0);
      Fillchar(PZP,sizeof(PZ),0);
      BlockRead(f2,istart,4);
      Blockread(f2,PSP.sNR,imaxPlen);
      Blockread(f2,iVer,4);
      Blockread(f2,PSP.iCode,4);
      BlockRead(f2,PSP.iZiele,4);
      BlockRead(f2,PSP.dLuftdruck,SizeOf(Double));
      BlockRead(f2,PSP.dTemperatur,SizeOf(double));
      BlockRead(f2,PSP.dFernrohr,SizeOf(double));
      BlockRead(f2,PSP.dEDM,SizeOf(double));
      BlockRead(f2,PSP.sBem,iBemLen);
      BlockRead(f2,PSP.iTag,4);
      BlockRead(f2,PSP.iMonat,4);
      Blockread(f2,PSP.iJahr,4);
      BlockRead(f2,PSP.dZeit,SizeOf(Double));

      For i:=1 To PSP.iZiele do
      begin
        BlockRead(f2,PZP[i].sNr,iMaxPlen);
        BlockRead(f2,PZP[i].iCode,4);
        BlockRead(f2,PZP[i].dTafel,SizeOf(Double));
        BlockRead(f2,PZP[i].dReflektor,SizeOf(Double));
        BlockRead(f2,PZP[i].dHz0,SizeOf(Double));
        BlockRead(f2,PZP[i].dHz1,SizeOf(Double));
        BlockRead(f2,PZP[i].dHz2,SizeOf(Double));
        BlockRead(f2,PZP[i].dStrecke,SizeOf(Double));
        BlockRead(f2,PZP[i].dSeitw,SizeOf(Double));
        BlockRead(f2,PZP[i].dDH,SizeOf(Double));
        BlockRead(f2,PZP[i].dZD0,SizeOf(Double));
        BlockRead(f2,PZP[i].dZD1,SizeOf(Double));
        BlockRead(f2,PZP[i].dZD2,SizeOf(Double));
        BlockRead(f2,PZP[i].dEDMNR,SizeOf(Double));
        BlockRead(f2,PZP[i].dDist,SizeOf(Double));
        BlockRead(f2,PZP[i].dExz,SizeOf(Double));
        BlockRead(f2,PZP[i].lDI,SizeOf(Boolean));
        BlockRead(f2,PZP[i].sBem,iBemLen);
      end;

      seek(f1,iEnd);
      iStart:=Filepos(f1);
      iStart:=iEnd;
      BlockWrite(f1,iEnd,4);
      BlockWrite(f1,PSP.sNR,imaxPlen);
      BlockWrite(f1,iVer,4);
      BlockWrite(f1,PSP.iCode,4);
      BlockWrite(f1,PSP.iZiele,4);
      BlockWrite(f1,PSP.dLuftdruck,SizeOf(Double));
      BlockWrite(f1,PSP.dTemperatur,SizeOf(double));
      BlockWrite(f1,PSP.dFernrohr,SizeOf(double));
      BlockWrite(f1,PSP.dEDM,SizeOf(double));
      BlockWrite(f1,PSP.sBem,iBemLen);
      BlockWrite(f1,PSP.iTag,4);
      BlockWrite(f1,PSP.iMonat,4);
      BlockWrite(f1,PSP.iJahr,4);
      BlockWrite(f1,PSP.dZeit,SizeOf(Double));
      For i:=1 To PSP.iZiele do
      begin
        BlockWrite(f1,PZP[i].sNr,iMaxPlen);
        BlockWrite(f1,PZP[i].iCode,4);
        BlockWrite(f1,PZP[i].dTafel,SizeOf(Double));
        BlockWrite(f1,PZP[i].dReflektor,SizeOf(Double));
        BlockWrite(f1,PZP[i].dHz0,SizeOf(Double));
        BlockWrite(f1,PZP[i].dHz1,SizeOf(Double));
        BlockWrite(f1,PZP[i].dHz2,SizeOf(Double));
        BlockWrite(f1,PZP[i].dStrecke,SizeOf(Double));
        BlockWrite(f1,PZP[i].dSeitw,SizeOf(Double));
        BlockWrite(f1,PZP[i].dDH,SizeOf(Double));
        BlockWrite(f1,PZP[i].dZD0,SizeOf(Double));
        BlockWrite(f1,PZP[i].dZD1,SizeOf(Double));
        BlockWrite(f1,PZP[i].dZD2,SizeOf(Double));
        BlockWrite(f1,PZP[i].dEDMNR,SizeOf(Double));
        BlockWrite(f1,PZP[i].dDist,SizeOf(Double));
        BlockWrite(f1,PZP[i].dExz,SizeOf(Double));
        BlockWrite(f1,PZP[i].lDI,SizeOf(Boolean));
        BlockWrite(f1,PZP[i].sBem,iBemLen);
      end;
      inc(n);
      iEnd:=FilePos(f1);
      Seek(f1,iStart);
      iEnd:=iEnd+1;  // In GeoBasic hat das erste Byte den Index 1 und nicht 0 wie hier
      BlockWrite(f1,iEnd,4);
      iEnd:=iEnd-1;
    end;
    Closefile(f1);
    CloseFile(f2);
    Showmessage(Format('%d Standpunkte importiert',[n]));
  end;
end;

procedure TForm1.ToolButton20Click(Sender: TObject);
begin
  ImportTrigmessBin;
  BuildPIndex;
  ToolButton11Click(sender);
end;

procedure Tform1.ReadIniFile;
Var
  IniFile : TIniFile;
begin
  IniFile:=TIniFile.Create(ChangeFileExt( Application.ExeName, '.INI' ));
  MaxDH:=IniFile.ReadFloat('TRIGMESSPAR','MAXDH',0.03);
  MaxDI:=IniFile.ReadFloat('TRIGMESSPAR','MAXDI',0.03);
  MaxHZ:=IniFile.ReadFloat('TRIGMESSPAR','MAXHZ',0.005);
  MaxZD:=IniFile.ReadFloat('TRIGMESSPAR','MAXZD',0.005);
  IniFile.Free;
end;

procedure TForm1.SaveIniFile;
Var
  IniFile : TIniFile;
begin
  IniFile:=TIniFile.Create(ChangeFileExt( Application.ExeName, '.INI' ));
  IniFile.WriteFloat('TRIGMESSPAR','MAXDH',MAXDH);
  IniFile.WriteFloat('TRIGMESSPAR','MAXDI',MAXDI);
  IniFile.WriteFloat('TRIGMESSPAR','MAXHZ',MAXHZ);
  IniFile.WriteFloat('TRIGMESSPAR','MAXZD',MAXZD);
  IniFile.Free;
end;

procedure TForm1.ToolButton21Click(Sender: TObject);
begin
  ReadIniFile;
  Form2.Show;
end;

procedure TForm1.ComboBoxZPSelect(Sender: TObject);
begin
  LiesStandpunkt(integer(ComboBoxZP.Items.Objects[ComboBoxZP.ItemIndex]));
  statusbar1.SimpleText:=format('Standpunkt %d von %d',[ComboBoxPS.ItemIndex+1,ComboBoxPS.Items.Count]);
  Statusbar1.Update;
end;

end.
